from queue import PriorityQueue
from heapq import heappush, heappop
import math


"""
INSERT DESCRIPTION



"""

def getMedian(alist):
    tmp = list(alist)
    tmp.sort()
    alen = len(tmp)
    if (alen % 2) == 1:
        return tmp[alen // 2]
    else:
        return (tmp[alen // 2] + tmp[(alen // 2) - 1]) / 2
    

def normalizeColumn(column):
    median = getMedian(column)
    asd = sum([abs(x - median) for x in column]) / len(column)
    result = [(x - median) / asd for x in column]
    return result

class hClusterer:
    """ this clusterer assumes that the first column of the data is a label
    not used in the clustering. The other columns contain numeric data"""
    
    def __init__(self, filename):
        file = open(filename)
        self.data = {}
        self.counter = 0
        self.queue = PriorityQueue()
        lines = file.readlines()
        file.close()
        header = lines[0].split(',')
        self.cols = len(header)
        self.data = [[] for i in range(len(header))]
        for line in lines[1:]:
            cells = line.split(',')
            toggle = 0
            for cell in range(self.cols):
                if toggle == 0:
                   self.data[cell].append(cells[cell])
                   toggle = 1
                else:
                    self.data[cell].append(float(cells[cell]))
        # now normalize number columns
        for i in range(1, self.cols):
                self.data[i] = normalizeColumn(self.data[i])

        # now push distances on queue        
        rows = len(self.data[0])              
        finished = []

        for i in range(rows):
            minDistance = 99999
            nearestNeighbor = 0
            #nearestN
            neighbors = {}
            for j in range(rows):
                if i != j and i not in finished:
                    dist = self.distance(i, j)
                    if i < j:
                        pair = (i,j)
                    else:
                        pair = (j,i)
                    neighbors[j] = (pair, dist)
                    if dist < minDistance:
                        minDistance = dist
                        nearestNeighbor = j
                        nearestNum = j
            # create nearest Pair
            if i < nearestNeighbor:
                nearestPair = (i, nearestNeighbor)
            else:
                nearestPair = (nearestNeighbor, i)
                
            # put instance on priority queue    
            self.queue.put((minDistance, self.counter, [[self.data[0][i]], [self.data[0][nearestNeighbor], minDistance, nearestPair], neighbors]))
            print(self.data[0][i], self.data[0][nearestNeighbor], minDistance, nearestPair)
            self.counter += 1
    

    def distance(self, i, j):
        sumSquares = 0
        for k in range(1, self.cols):
            sumSquares += (self.data[k][i] - self.data[k][j])**2
        return math.sqrt(sumSquares)
            

    def cluster(self):
         done = False
         while not done:
             topOne = self.queue.get()
             nearestPair = topOne[2][1][2]
             print(nearestPair)
             #print('TOP', topOne)
             if not self.queue.empty():
                 nextOne = self.queue.get()
                 nearPair = nextOne[2][1][2]
                 tmp = []
                 while nearPair != nearestPair:
                     print(nearPair)
                     print ("\n\nWHOOPS" , topOne)
                     print (nextOne)
                     tmp.append((nextOne[0], self.counter, nextOne[2]))
                     self.counter += 1
                     nextOne = self.queue.get()
                     nearPair = nextOne[2][1][2]
                 for item in tmp:
                     self.queue.put(item)

                 print(nearPair)
                 #print('NEXT', nextOne)
                 curCluster = [topOne[2][0], nextOne[2][0]]
                 #print(curCluster)
                 # now merge neighbors
                 minDistance = 99999
                 nearestPair = ()
                 nearestNeighbor = ''
                 merged = {}
                 nNeighbors = nextOne[2][2]
                 for (key, value) in topOne[2][2].items():
                    if key in nNeighbors:
                        if nNeighbors[key][1] < value[1]:
                             dist =  nNeighbors[key]
                        else:
                            dist = value
                        if dist[1] < minDistance:
                             minDistance =  dist[1]
                             nearestPair = dist[0]
                             nearestNeighbor = key
                        merged[key] = dist
                    
                 if merged == {}:
                    return curCluster
                 else:
                    print("JOINED")
                    print (curCluster, "\n\n")
                    #print((minDistance, [curCluster, [nearestNeighbor, minDistance], merged]))
                    self.queue.put( (minDistance, self.counter, [curCluster, [nearestNeighbor, minDistance, nearestPair], merged]))
                    self.counter += 1
                    #print("AFTER\n")
                               
                        
                         

def xdistance(point1, point2):
    return math.sqrt(sum([(x[0] -x[1])**2 for x in zip(point1, point2)]))            



filename = '//Users/raz/Dropbox/guide/pg2dm-python/ch8/dogs2.csv'
hg = hClusterer(filename)
print (hg.cluster())

